<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/tools.php";
include_once "include/mime.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/import.php";

$select_folder   = pg_escape_string($_REQUEST['select_folder']);
$select_album    = pg_escape_string($_REQUEST['select_album']);
$type            = isset($_REQUEST['type']) ? $_REQUEST['type'] : FALSE;
$selection       = pg_escape_string(isset($_REQUEST['selection']) ? $_REQUEST['selection'] : "");
$to_update       = isset($_REQUEST['to_update']) ? $_REQUEST['to_update'] : array();
$recursive       = isset($_REQUEST['recursive']);
$set_generate_images = $_REQUEST['set_generate_images'];

$compress_pages = false;   /* Explicitly disable it here */
set_time_limit(0); /* Explicitly disable timeouts here */

$database = site_prolog(PO_USER_TYPE_USER);

if (!$type || !sizeof($to_update)) {
  if ($set_generate_images != 't') {
    site_push_error($strings['errors']['invalid_options']);
    header("Location: my.tools.php?selector=".$tools_data['bulkupdate']['idx']);
    site_epilog($database);
    exit();
  }
 }

site_header($strings['generic']['bulk_update']);
site_navigator(10);
site_navigator_status(emit_a("user.php", $strings['generic']['users'])." : ".$strings['generic']['bulk_update'], "");

print "&nbsp;<br/>";
display_navigator_box_top($tools_data['bulkupdate']['idx'], $tools_data, "100%");

$update_photo_sql = "";
$update_photo_tech_sql = "";

$set_keyword = "";
$clear_keyword = "";

foreach ($to_update as $field) {
  switch ($field) {
  case 'set_title':
    $set_title                  = pg_escape_string($_REQUEST['title']);
    $update_photo_sql .= " title = '$set_title', ";
    break;
  case 'set_author':
    $set_author                 = pg_escape_string($_REQUEST['author']);
    $update_photo_sql .= " author = '$set_author', ";
    break;
  case 'set_keyword':
    $set_keyword                = $_REQUEST['set_keywords'];
    break;
  case 'clear_keyword':
    $clear_keyword                = $_REQUEST['clear_keywords'];
    break;
  case 'set_headline':
    $set_headline               = pg_escape_string($_REQUEST['headline']);
    $update_photo_sql .= " headline = '$set_headline', ";
    break;
  case 'set_caption_writer':
    $set_caption_writer         = pg_escape_string($_REQUEST['caption_writer']);
    $update_photo_sql .= " caption_writer = '$set_caption_writer', ";
    break;
  case 'set_caption':
    $set_caption                = pg_escape_string($_REQUEST['caption']);
    $update_photo_sql .= " caption = '$set_caption', ";
    break;
  case 'set_category':
    $set_category               = pg_escape_string($_REQUEST['category']);
    $update_photo_sql .= " category = '$set_category', ";
    break;
  case 'set_supplemental_category':
    $set_supplemental_category  = pg_escape_string($_REQUEST['supplemental_category']);
    $update_photo_sql .= " supplemental_category = '$set_supplemental_category', ";
    break;
  case 'set_credit':
    $set_credit                 = pg_escape_string($_REQUEST['credit']);
    $update_photo_sql .= " credit = '$set_credit', ";
    break;
  case 'set_copyright':
    $set_copyright              = pg_escape_string($_REQUEST['copyright']);
    $update_photo_sql .= " copyright_statement = '$set_copyright', ";
    break;
  case 'set_web_statement':
    $set_web_statement          = pg_escape_string($_REQUEST['web_statement']);
    $update_photo_sql .= " web_statement = '$set_web_statement', ";
    break;
  case 'set_instructions':
    $set_instructions           = pg_escape_string($_REQUEST['instructions']);
    $update_photo_sql .= " instructions = '$set_instructions', ";
    break;
  case 'set_source':
    $set_source                 = pg_escape_string($_REQUEST['source']);
    $update_photo_sql .= " source = '$set_source', ";
    break;
  case 'set_transmission_reference':
    $set_transmission_reference = pg_escape_string($_REQUEST['transmission_reference']);
    $update_photo_sql .= " transmission_reference = '$set_transmission_reference', ";
    break;
  case 'set_date_of_exposure':
    $set_date_of_exposure = check_date_validity($_REQUEST['exposure_timestamp']);
    $update_photo_sql .= " date_of_exposure = $set_date_of_exposure, ";
    break;
  case 'set_location':
    $set_location                 = pg_escape_string($_REQUEST['location']);
    $update_photo_sql .= " location = $set_location, ";
    break;
  case 'set_access_rights':
    $set_access_rights                 = pg_escape_string($_REQUEST['access_rights']);
    $update_photo_sql .= " access_rights = $set_access_rights, ";
    break;
  case 'set_hide_original':
    $set_hide_original                 = pg_escape_string($_REQUEST['hide_original']);
    $update_photo_sql .= " hide_original = '$set_hide_original', ";
    break;
  case 'set_store_url':
    $set_store_url                 = pg_escape_string($_REQUEST['store_url']);
    $update_photo_sql .= " store_url = '$set_store_url', ";
    break;
  case 'set_remark':
    $set_remark                 = pg_escape_string($_REQUEST['remark']);
    $update_photo_sql .= " comments = '$set_remark', ";
    break;
  case 'set_camera':
    $set_camera                 = pg_escape_string($_REQUEST['camera']);
    $update_photo_tech_sql .= " camera = $set_camera, ";
    break;
  case 'set_camera_metering':
    $set_camera_metering        = pg_escape_string($_REQUEST['camera_metering']);
    $update_photo_tech_sql .= " camera_metering = $set_camera_metering, ";
    break;
  case 'set_camera_program':
    $set_camera_program                 = pg_escape_string($_REQUEST['camera_program']);
    $update_photo_tech_sql .= " camera_program = $set_camera_program, ";
    break;
  case 'set_lens':
    $set_lens                 = pg_escape_string($_REQUEST['lens']);
    $update_photo_tech_sql .= " lens = $set_lens, ";
    break;
  case 'set_focal_length':
    $set_focal_length                = pg_escape_string($_REQUEST['focal_length']);
    $update_photo_tech_sql .= " focal_length = $set_focal_length, ";
    break;
  case 'set_filter':
    $set_filter                 = pg_escape_string($_REQUEST['filter']);
    $update_photo_tech_sql .= " filter = $set_filter, ";
    break;
  case 'set_film':
    $set_film                 = pg_escape_string($_REQUEST['film']);
    $update_photo_tech_sql .= " film = $set_film, ";
    break;
  case 'set_iso_override':
    $set_iso_override                = pg_escape_string($_REQUEST['iso_override']);
    $update_photo_tech_sql .= " iso_override = $set_iso_override, ";
    break;
  case 'set_aperture':
    $set_aperture                 = pg_escape_string($_REQUEST['aperture']);
    $update_photo_tech_sql .= " aperture = $set_aperture, ";
    break;
  case 'set_shutter':
    $set_shutter                 = pg_escape_string($_REQUEST['shutter']);
    $update_photo_tech_sql .= " shutter = $set_shutter, ";
    break;
  case 'set_exp_comp':
    $set_exp_comp                 = pg_escape_string($_REQUEST['exp_comp']);
    $update_photo_tech_sql .= " exposure_comp = $set_exp_comp, ";
    break;
  case 'set_exp_diff':
    $set_exp_diff                 = pg_escape_string($_REQUEST['exp_diff']);
    $update_photo_tech_sql .= " ev_difference = $set_exp_diff, ";
    break;
  case 'set_flash':
    $set_flash                 = pg_escape_string($_REQUEST['flash']);
    $update_photo_tech_sql .= " flash = $set_flash, ";
    break;
  case 'set_flash_mode':
    $set_flash_mode                 = pg_escape_string($_REQUEST['flash_mode']);
    $update_photo_tech_sql .= " flash_mode = $set_flash_mode, ";
    break;
  case 'set_flash_comp':
    $set_flash_comp                 = pg_escape_string($_REQUEST['flash_comp']);
    $update_photo_tech_sql .= " flash_comp = $set_flash_comp, ";
    break;
  case 'set_scanner':
    $set_scanner                = pg_escape_string($_REQUEST['scanner']);
    $update_photo_tech_sql .= " scanner = $set_scanner, ";
    break;
  case 'set_scan_params':
    $param               = pg_escape_string($_REQUEST['scan_resolution']);
    $update_photo_tech_sql .= " scan_resolution = $param, ";
    $param               = pg_escape_string($_REQUEST['scan_bitdepth']);
    $update_photo_tech_sql .= " scan_bitdepth = $param, ";
    $param               = pg_escape_string($_REQUEST['scan_multiscan']);
    $update_photo_tech_sql .= " scan_multiscan = $param, ";
    break;
  case 'set_support':
    $set_support                = pg_escape_string($_REQUEST['support']);
    $update_photo_tech_sql .= " support = $set_support, ";
    break;
  case 'set_geo_location':
    $pos = pg_escape_string(parse_latitude($_REQUEST['latitude']));
    if ($pos == "") $pos = "null";
    $update_photo_tech_sql .= " latitude = $pos, ";
    $pos = pg_escape_string(parse_latitude($_REQUEST['longitude']));
    if ($pos == "") $pos = "null";
    $update_photo_tech_sql .= " longitude = $pos, ";
    $pos = pg_escape_string($_REQUEST['altitude']);
    if ($pos == "") $pos = "null";
    $update_photo_tech_sql .= " altitude = $pos, ";
    $pos = pg_escape_string($_REQUEST['direction']);
    if ($pos == "") $pos = "null";
    $update_photo_tech_sql .= " direction = $pos, ";
    break;
  default:
    # XXXX we should never get here!
    break;
  }
}

switch ($type) {
 case 'folder':
  if ($select_folder == "all") {
    $sql_selector = " p.users = $po_user[id] ";
  } else {
    if ($recursive) {
        $sql_selector = " p.folder in (select * from folder_and_subfolders($select_folder))";
    } else {
    	$sql_selector = " p.folder = $select_folder ";
    }
  }
  break;
 case 'album':
  if ($recursive) {
     $sql_selector = " a.album in (select * from album_and_subalbums($select_album)) ";
  } else {
     $sql_selector = " a.album = $select_album ";
  }

  $sql_selector = " p.identifier in( select photo from album_content a where $sql_selector) ";
    
  break;
 case 'spool':
   $sql_selector = " p.identifier in( select photo from album_content where album = $po_user[spool_album])";
  break;
 case 'list':
   $sql_selector = " p.identifier in( $selection )";
   break;
 default:
   site_push_error($strings['errors']['invalid_operation']);
   header("Location: my.tools.php?selector=".$tools_data['bulkupdate']['idx']);
   site_epilog($database);
   exit();
   break;
}

/* Ensure users only update files they own */
if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
  $sql_selector = " p.users = $po_user[id] AND $sql_selector ";
 }

$num_of_updates = pg_fetch_row(pg_query($database, "
  select count(identifier) from photo p
   where $sql_selector"));

$result = pg_query($database, "begin");


if ($result && $update_photo_sql != "") {
  $update_photo_sql = substr($update_photo_sql, 0, strlen($update_photo_sql) - 2);

  //  print "<li>$update_photo_sql</li>";
  //  print "<li>$sql_selector</li>";

  $result = pg_query($database, "
  update photo set
     $update_photo_sql where identifier in (select identifier from photo p
   where $sql_selector)");
}

if ($result && $update_photo_tech_sql != "") {
  $update_photo_tech_sql = substr($update_photo_tech_sql, 0, strlen($update_photo_tech_sql) - 2);

  $query = "update photo_tech set
     $update_photo_tech_sql
   where photo in (select identifier from photo p where $sql_selector)";
    
  // print "<li><pre>$query</pre></li>";

  $result = pg_query($database,$query);
}

if ($result && $set_keyword != "") {
  if (strstr($set_keyword, ";"))
    $keywords = semi_string_to_array($set_keyword);
  else
    $keywords = space_string_to_array($set_keyword);

  foreach ($keywords as $keyword) {
    $keyword = strtolower(trim($keyword));
    $keyword = trim($keyword, ','); /* Trailing commas */
    $keyword = trim($keyword);
    if ($keyword == "") continue;
    $keyword = pg_escape_string($keyword);

    $result = pg_query($database, "insert into photo_keywords (photo, keyword)
                  select p.identifier, '$keyword' from photo p where $sql_selector and not exists (select k.photo from photo_keywords k where k.photo = p.identifier and k.keyword = '$keyword')");
  }
 }

if ($result && $clear_keyword != "") {
  if (strstr($clear_keyword, ";"))
    $keywords = semi_string_to_array($clear_keyword);
  else
    $keywords = space_string_to_array($clear_keyword);

  foreach ($keywords as $keyword) {
      $keyword = strtolower(trim($keyword));
      $keyword = trim($keyword, ','); /* Trailing commas */
      $keyword = trim($keyword);
      if ($keyword == "") continue;
      $keyword = pg_escape_string($keyword);
      
      $query = "delete from photo_keywords where keyword = '$keyword' and photo in (select p.identifier from photo p where $sql_selector)";
      
      $result = pg_query($database, $query);
  }
 }

if ($result) {
    pg_query($database, "commit");
    print "<p align=\"left\">".$strings['tools']['num_photos_updated'].": $num_of_updates[0]</p>";
 } else {
    pg_query($database, "rollback");
    // print "<pre>$query</pre>";
    print err_str($strings['errors']['db_insert_failed']);
 }

if ($result && $set_generate_images == 't') {
  print "<div align=\"left\"><ul>";

  $counter = 0;
$query = "
      select get_image_path(v.identifier, 1) as thumb_path, 
             get_image_path(v.identifier, 2) as preview_path, 
             get_image_path(v.identifier, 3) as original_path, 
             title, p.identifier, colorspace, orientation, v.identifier as version
        from photo p, photo_version v
       where p.identifier = v.photo
         and $sql_selector
       order by p.identifier";
  $photo = pg_query($database, $query);
  // print "<pre>$query</pre>";
  $num_of_photos = pg_num_rows($photo);
  
  for ($counter = 0; $counter < $num_of_photos; $counter++) {
    $photo_data = pg_fetch_row($photo, $counter);
    
    if (($current_volume = get_current_volume($database, FALSE)) == FALSE) {
      print err_str($strings['errors']['failed_volume']);
      break;
    }

    pg_query($database, "begin");
    
    $next_index = pg_fetch_row(pg_query($database, "select nextval('photo_id_sequence')"));

    $camera_profile = pg_fetch_row(pg_query($database, "
    select raw_icc_profile 
      from photo_tech, camera, camera_type
     where photo_tech.photo = $photo_data[4]
       and photo_tech.camera = camera.identifier
       and camera.type = camera_type.identifier"));

    $orientation = orientation_to_xform($database, $photo_data[6]);    
    $original_name = $image_repository_path ."/". $photo_data[2];
    $original_file_type   = strtolower(substr($original_name, strrpos($original_name, ".") + 1));
    $multi_page_parameter = $mime_type[$original_file_type]['page'];
    $decoder              = $mime_type[$original_file_type]['decoder'];

    $thumb = "$current_volume/00002/$next_index[0]" . "_1." . $po_options['thumb_format'];
    $preview = "$current_volume/00001/$next_index[0]" . "_2." . $po_options['preview_format'];
    
    print "<li>".$strings['tools']['regenerating_images']."<a href=\"photo.php?photo=$photo_data[4]&amp;ver=$photo_data[7]\"># $photo_data[4]-$photo_data[7]: $photo_data[3]</a>.<ul>";      

    $image_data = array();
    $image_data['jpgfromraw'] = FALSE;

    if ($po_options['watermark_location'] &&
	$po_options['watermark_brightness'] &&
	$po_options['watermark_photo']) {
      $watermark = $po_options['watermark_photo'];
    } else {
      $watermark = "null";
    }
    if ($result) {
      $temporary_ppm_file = import_raw_decode($original_name, $decoder, $camera_profile[0], TRUE, $image_data);
      if ($temporary_ppm_file) {
	$original_name = $temporary_ppm_file;
      } 
      $result = import_generate_preview($original_name, $image_repository_path."/".$preview, TRUE, $multi_page_parameter, $orientation, $photo_data[5]);
    }
    
    if ($result) {
      $result = transfer_metadata(NULL, $original_name, $preview, TRUE, TRUE);
    }

    if ($result) {
      $image_dimension = po_get_image_size($image_repository_path."/".$preview);
      $size = filesize($image_repository_path."/".$preview);
      $result = pg_query($database, "INSERT INTO files 
     (identifier, version, size, x_res, y_res, path, filesize, params, comments, watermark) 
      VALUES ((select nextval('files_id_sequence')), $photo_data[7], 2, 
              $image_dimension[0], $image_dimension[1], '$preview',
              $size, '', '', $watermark)");
    }
    
    /* Thumbnail */
    if ($result) {
      $result = import_generate_thumbnail($original_name, $image_repository_path."/".$thumb, TRUE, $multi_page_parameter, $orientation, $photo_data[5]);
    }

    if ($result) {
      $image_dimension = po_get_image_size($image_repository_path."/".$thumb);
      $size = filesize($image_repository_path."/".$thumb);
      $result = pg_query($database, "INSERT INTO files 
     (identifier, version, size, x_res, y_res, path, filesize, params, comments, watermark) 
      VALUES ((select nextval('files_id_sequence')), $photo_data[7], 1, 
              $image_dimension[0], $image_dimension[1], '$thumb', 
              $size, '', '', null)");
    }
    
    if ($temporary_ppm_file) {
      unlink($temporary_ppm_file);
    }

    // XXX -- Kick the date_changed fields via the DB drigger
    if ($result) {
      $result = pg_query($database, "update photo_version set date_changed = now() where identifier = $photo_data[7] ");
    }
    
    /* Delete the old files! */
    if ($result) {
      $result = pg_query($database, "delete from files where path in ('$photo_data[0]', '$photo_data[1]')");
    }
    if ($result) {
      $err = error_reporting(0);
      unlink($image_repository_path . "/" .$photo_data[0]);
      unlink($image_repository_path . "/" .$photo_data[1]);
      error_reporting($err);
    }
    
    print "</ul></li>";
    
    if ($result) {
      pg_query($database, "commit");
    } else {
      pg_query($database, "rollback");
      break;
    }
  }

  print "</ul></div>";
}

print $thm_elem['button.back.2'];

display_navigator_box_bottom("100%");

site_footer($database);
site_epilog($database);

?>
