<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2007 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/color.php";
include_once "include/mail.php";

$user_id = 0;
$registration_error = 0;

$database = site_prolog();

$username                     = pg_escape_string($_REQUEST['username']);
$password_1                   = pg_escape_string($_REQUEST['password_1']);
$password_2                   = pg_escape_string($_REQUEST['password_2']);
$first_name                   = pg_escape_string($_REQUEST['first_name']);
$last_name                    = pg_escape_string($_REQUEST['last_name']);
$email                        = pg_escape_string($_REQUEST['email']);
$lang = isset($_REQUEST['lang']) ? $_REQUEST['lang'] : $po_options['lang'];

if (($po_options_default['new_user_type'] == PO_USER_TYPE_DISABLED) && 
    ($po_user['type'] < PO_USER_TYPE_USER)) {
  site_push_error($strings['errors']['registration_disabled']);
  header("Location: login.php");
  exit();
}

if ($username!="") {
  $result = pg_fetch_row(pg_query($database, "select identifier from users where username='$username'"));
  if ($result[0] != 0) {
    $registration_error = 1;
  } elseif (($password_2 != $password_1) || (($password_2 == "") && ($password_1 == ""))) {
    $registration_error = 2;
  } elseif (($first_name == "") || ($last_name == "")) {
    $registration_error = 3;
  } elseif ($email == "") {
    $registration_error = 4;
  } else {

    if ($po_user['type'] == PO_USER_TYPE_ADMIN) {
      $user_type = $_REQUEST['new_user_type'];
    } elseif ($po_user['type'] == PO_USER_TYPE_USER) {
      $user_type = PO_USER_TYPE_CLIENT;
    } else {
      $user_type = $po_options_default['new_user_type'];
    }

    /* Optional */
    $url                          = pg_escape_string($_REQUEST['url']);
    $phone                        = pg_escape_string($_REQUEST['phone']);
    $company                      = pg_escape_string($_REQUEST['company']);
    $address1                     = pg_escape_string($_REQUEST['address1']);
    $address2                     = pg_escape_string($_REQUEST['address2']);
    $city                         = pg_escape_string($_REQUEST['city']);
    $zipcode                      = pg_escape_string($_REQUEST['zipcode']);
    $state                        = pg_escape_string($_REQUEST['state']);
    $country                      = pg_escape_string($_REQUEST['country']);
    
    pg_query($database, "begin");
    $new_user_id = pg_fetch_row(pg_query($database, "select nextval('users_id_sequence')"));
    $new_contact_info_id = pg_fetch_row(pg_query($database, "select nextval('contact_info_id_sequence')"));

    $user_id = $new_user_id[0];
    $my_contact_info_id = $new_contact_info_id[0];

    if (strlen($url) && (substr($url, 0, 7) != "http://"))
      $url = "http://".$url;

    $result = pg_query($database, "insert into contact_info (identifier, address1, address2, city, zipcode, state, country, phone, email, url)
                                   values ('$my_contact_info_id', '$address1', '$address2', '$city', '$zipcode', $state, $country, '$phone', '$email', '$url')");

    if ($result) {
      $result = pg_query($database, "insert into users (identifier, first_name, last_name, company, username, password, contact, member_since, type)
                                   values ('$user_id', '$first_name', '$last_name', '$company', '$username', '$password_1', '$my_contact_info_id', now(), $user_type)");
    }
    if ($result) { 
      $result = pg_query($database, "insert into folder (identifier, parent_folder, users, caption, access_rights)
                                    values (nextval('folder_id_sequence'), null, '$user_id', 'Trash', 3)");
    }
    if ($result) {
      $result = pg_query($database, "insert into album (identifier, parent_album, users, caption, access_rights, description)
             values (nextval('album_id_sequence'), null, $user_id,
         'Spool', 3, null)");
    }

    if ($result)
      $result = store_user_pref($database, $user_id, 'lang', $lang);
    if ($result)
      $result = store_user_pref($database, $user_id, 'quota_size', $po_options_default['quota_size']);
    if ($result)
      $result = store_user_pref($database, $user_id, 'quota_count', $po_options_default['quota_count']);
    if ($result)
      $result = store_user_pref($database, $user_id, 'bulk_upload_enable', $po_options_default['bulk_upload_enable']);

    /* Register the client association */
    if ($result && $po_user['type'] == PO_USER_TYPE_USER) {
      $result = pg_query($database, "insert into client (identifier, users, client, date_of_creation, status, trusted)
                               values (nextval('client_id_sequence'), '$po_user[id]', '$user_id', now(), 2, 't')");
    }

    if (!$result) {
      $registration_error = 5;
      pg_query($database, "rollback");
    } else {
      pg_query($database, "commit");
      if ($po_user['type'] <= PO_USER_TYPE_CLIENT) {
	$po_user['id'] = $user_id;
	$po_user['type'] = $user_type;
	$po_user['username'] = $username;
	$po_user['first_name'] = $first_name;
	$po_user['last_name'] = $last_name;
	site_update_session();
      }
      send_login_information($database, $email);
    }
  }
}

if (!$registration_error && ($user_id!=0)) {
  if ($po_user['type'] == PO_USER_TYPE_ADMIN) {
    header("Location: admin.php?selector=2");
  } elseif ($po_user['type'] == PO_USER_TYPE_USER) {
    header("Location: my.datebook.php");
  } else {
    header("Location: login.php");  
  }
  exit();
}

site_header($strings['generic']['register']);
site_navigator(3);

switch ($registration_error) {
 case 1:
   site_navigator_status(err_str($strings['errors']['username_registered'] . ": <b>$username</b>"), "");
   break;
 case 2:
   site_navigator_status(err_str($strings['errors']['password_mismatch']), "");
   break;
 case 3:
   site_navigator_status(err_str($strings['errors']['names_mandatory']), "");
   break;
 case 4:
   site_navigator_status(err_str($strings['errors']['email_mandatory']), "");
   break;
 case 5:
   site_navigator_status(err_str($strings['errors']['db_insert_failed']), "");
   break;
 default:
   site_navigator_status("<a href=\"login.php\">".$strings['generic']['login']."</a> : ".$strings['generic']['user_registration'] , $strings['user']['registration_text']);
}

$all_states = pg_query($database, "select identifier, value from state order by value");
$all_countries = pg_query($database, "select identifier, value from country order by value");

print "&nbsp;<br/>\n";
print "<form action=\"register.php\" method=\"post\">\n";
print "<table class=\"search\">\n";
print "<tr><td><b>".$strings['generic']['username']."</b></td><td><input tabindex=\"1\" type=\"text\" name=\"username\" value=\"$username\" size=\"35%\"/></td></tr>\n";
print "<tr><td><b>".$strings['generic']['password']."</b></td><td><input tabindex=\"2\" type=\"password\" name=\"password_1\" size=\"35%\"/></td></tr>\n";
print "<tr><td><b>".$strings['generic']['password_again']."</b></td><td><input tabindex=\"3\" type=\"password\" name=\"password_2\" size=\"35%\"/></td></tr>\n";
print "<tr><td><b>".$strings['user']['first_name']."</b></td><td><input tabindex=\"4\" type=\"text\" name=\"first_name\" value=\"$first_name\" size=\"35%\"/></td></tr>\n";
print "<tr><td><b>".$strings['user']['last_name']."</b></td><td><input tabindex=\"5\" type=\"text\" name=\"last_name\" value=\"$last_name\" size=\"35%\"/></td></tr>\n";
print "<tr><td><b>".$strings['user']['email']."</b></td><td><input tabindex=\"6\" type=\"text\" name=\"email\" value=\"$email\" size=\"35%\"/></td></tr>\n";

if ($po_user['type'] == PO_USER_TYPE_ADMIN) {
  $all_user_types = pg_query($database, "
  select user_type.identifier, user_type.value
    from user_type");
  print "<tr><td><b>".$strings['generic']['type']."</b></td><td>";
  display_combo("new_user_type", $all_user_types, $po_options_default['new_user_type'], "", 1);
  print "</td></tr>\n";
 }

print emit_language_combo($lang);
print "<tr><td>".$strings['user']['web']."</td><td><input tabindex=\"7\" type=\"text\" name=\"url\" value=\"$url\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user']['phone']."</td><td><input tabindex=\"8\" type=\"text\" name=\"phone\" value=\"$phone\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user']['company']."</td><td><input tabindex=\"9\" type=\"text\" name=\"company\" value=\"$company\" size=\"35%\"/></td></tr>\n";
print "<tr><td valign=\"center\" rowspan=\"2\" >".$strings['user']['address']."</td><td><input tabindex=\"10\" type=\"text\" name=\"address1\" value=\"$address1\" size=\"35%\"/></td></tr><tr><td><input tabindex=\"11\" type=\"text\" name=\"address2\" value=\"$address2\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user']['city']."</td><td><input tabindex=\"12\" type=\"text\" name=\"city\" value=\"$city\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user']['post_code']."</td><td><input tabindex=\"13\" type=\"text\" name=\"zipcode\" value=\"$zipcode\" size=\"35%\"/></td></tr>\n";
print "<tr><td>".$strings['user']['state']."</td><td>"; display_combo("state", $all_states, $state, "", 0); print"</td></tr>\n";
print "<tr><td>".$strings['user']['country']."</td><td>"; display_combo("country", $all_countries, $country, "", 0); print"</td></tr>\n";
print "</table>\n";

print "<div align=\"center\">";
print $thm_elem['button.register'];
print $thm_elem['button.clear'];
print $thm_elem['button.cancel'];
print "</div>";
print "</form>\n";

site_footer($database);
site_epilog($database);
?>
