
--  Copyright (C) 2002, 2003, 2004, 2005, 2006 Balint Kis (balint@k-i-s.net)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.25 to v2.26 patch
----------------------------------------------------------

-- BEGIN: MANY THANKS TO SOLOMON PEACHY (PITHA) FOR THIS GREAT CONTRIBUTION

alter table album add column description text;
alter table folder add column description text;

alter table photo_version add column colorspace integer;
update photo_version set colorspace = 1 where colorspace is null;
alter table photo_version alter colorspace set not null;

create sequence orientations_id_sequence start 1;
create table orientations (
  identifier             integer not null primary key,
  name                   varchar(100),
  im_transform           varchar(100)
);

insert into orientations values (nextval('orientations_id_sequence'), 'Normal (0 deg)',      ' ');
insert into orientations values (nextval('orientations_id_sequence'), 'Mirrored',            ' -flop ');
insert into orientations values (nextval('orientations_id_sequence'), 'Upsidedown',          ' -rotate 180 ');
insert into orientations values (nextval('orientations_id_sequence'), 'Upsidedown Mirrored', ' -flip ');
insert into orientations values (nextval('orientations_id_sequence'), '90 deg CW Mirrored',  ' -flip -rotate 90 ');
insert into orientations values (nextval('orientations_id_sequence'), '90 deg CCW',          ' -rotate 270 ');
insert into orientations values (nextval('orientations_id_sequence'), '90 deg CCW Mirrored', ' -flop -rotate 90 ');
insert into orientations values (nextval('orientations_id_sequence'), '90 deg CW',           ' -rotate 90 ');

alter table photo_version add column orientation integer references orientations(identifier);
update photo_version set orientation = 1 where orientation is null;
alter table photo_version alter orientation set not null;

-- END: MANY THANKS TO SOLOMON PEACHY (PITHA) FOR THIS GREAT CONTRIBUTION

create sequence shop_item_generator_rule_id_sequence start 1;
create table shop_item_generator_rule (
  identifier             integer not null primary key,
  users                  integer not null references users(identifier),
  shop_item              integer not null references shop_item(identifier),
  price                  numeric,
  currency               integer references currency(identifier),
  comment                text,
  date_of_creation       timestamp,
  date_of_last_edit      timestamp
);

create view view_shop_item_generator_rule as
  select shop_item_generator_rule.identifier,
         shop_category.caption as shop_category,
         shop_item.description as shop_item,
         currency.alpha_code as currency,
         shop_item_generator_rule.price,
         shop_item_generator_rule.comment,
         shop_item_generator_rule.date_of_creation,
         shop_item_generator_rule.date_of_last_edit,
         shop_item_generator_rule.users
    from shop_item_generator_rule, shop_category, shop_item, currency
   where shop_item_generator_rule.shop_item = shop_item.identifier
     and shop_item.category = shop_category.identifier
     and shop_item_generator_rule.currency = currency.identifier
   order by shop_item_generator_rule.date_of_creation;
